#include "Builder/GameBuilderDirector.h"

GameBuilderDirector::GameBuilderDirector(std::unique_ptr<IGameBuilder> ptr_builder,
    const sf::VideoMode& video_mode, const std::string& window_title, float dynamic_objects_ratio) :
        m_ptr_builder(std::move(ptr_builder)), m_video_mode(video_mode), m_window_title(window_title),
        m_dynamic_object_ratio(dynamic_objects_ratio) {}

std::unique_ptr<GameState> GameBuilderDirector::build(IStateManager& state_manager) {
    m_ptr_builder->create_rooms();
    m_ptr_builder->set_rooms_sides();
    m_ptr_builder->create_context(m_dynamic_object_ratio);
    m_ptr_builder->create_state(state_manager, m_video_mode, m_window_title);
    m_ptr_builder->set_all_to_state();
    return m_ptr_builder->get_game();
}